import java.util.ArrayList;
import java.util.Random;
public class NumberFinder {
  private int size;
  private int findMe;
  private int answer;
  private boolean isFound;
  private ArrayList<Integer> numbers;
  private Random random;
  
  
  public NumberFinder(int size, int findMe) {
    this.size = size;
    this.findMe = findMe;
    this.isFound = false;
    
    numbers = new ArrayList<Integer>();
    random = new Random();
        
    generateNumbers();  // creates a sequence of numbers in random order, with no duplicates
    
    while(!isFound) {
      guessNumber();
    }
    
    System.out.println("The answer is: " + answer);
  }
  
  private void generateNumbers() {
    while(numbers.size() <= size) {
      int num = random.nextInt(size);
      if(!numbers.contains(num)) {
        numbers.add(num);           // adds the new number to the ArrayList
        System.out.println("added :: " + num);
      }else{
        System.out.println("duplicate :: " + num);
      }
    }
    
    System.out.println(numbers);
  }
  
  private void guessNumber() {
    int index = random.nextInt(numbers.size() - 1));
    int pick = numbers.get(index);
    if(pick == findMe) {
      answer = pick;
      isFound = true;
    }else{
      numbers.remove(pick); // remove whatever number was guessed from the list of possible choices
    }
  }
  
}